<template>
    <v-row justify="center">
        <v-col cols="12" sm="10">
            <v-card class="elevation-3">
                <v-card-title>
                    Mes collaborateurs
                    <v-spacer></v-spacer>
                    <v-btn color="primary-light" outlined dark @click="goToForm">
                        <v-icon>mdi-plus</v-icon>
                        Inviter collaborateur
                    </v-btn>
                </v-card-title>
                <v-data-table :headers="headers" :items="collabList" :sort-by="['email']" class="elevation-1"
                    :loading="isLoading" loading-text="Récupération des données..." hide-default-footer>
                    <template v-slot:item.isActive="{ item }">
                        <v-icon :color="item.isActive ?'green': 'red'">{{item.isActive ? 'mdi-check': 'mdi-close'}}
                        </v-icon>
                    </template>
                    <template v-slot:item.actions="{ item }">
                        <v-icon small @click="handleDelete(item)">
                            mdi-delete
                        </v-icon>
                    </template>
                </v-data-table>
            </v-card>
        </v-col>
        <v-dialog v-model="dialog" width="200">
            <v-card>
                <v-card-title>
                  <v-spacer></v-spacer>
                    Confirmation
                  <v-spacer></v-spacer>
                </v-card-title>
                <v-card-actions>
                    <v-btn color="success" small @click="handleConfirm">
                        Valider
                    </v-btn>
                    <v-spacer></v-spacer>
                    <v-btn color="error" small @click="dialog = false">
                        Fermer
                    </v-btn>
                </v-card-actions>
            </v-card>
        </v-dialog>
    </v-row>
</template>

<script>
import { mapFields } from 'vuex-map-fields';
import { mapActions } from 'vuex';

import NotificationMixin from '../../../mixins/NotificationMixin';

export default {
  name: 'AdminCollaboratorsList',
  mixins: [NotificationMixin],
  components: {
    // LoginForm,
    // Loading
  },
  data() {
    return {
      headers: [
        {
          text: 'Email',
          align: 'start',
          sortable: false,
          value: 'email',
        },
        { text: 'Nom', value: 'firstName' },
        { text: 'Prénom', value: 'lastName' },
        { text: 'Compte actif', align: 'center', value: 'isActive' },
        { text: 'Supprimer',align: 'center', value: 'actions', sortable: false },
      ],
      collabList:[],
      toBeDeletedItem:null,
      dialog: false,
      confirmDelete: false
    }
  },
  computed: {

    ...mapFields('user', ['userInfos', 'loggedIn', 'tempProfilePicture']),
    ...mapFields('admin', ['company', 'companyFound', 'isLoading']),

  },
  created() {
    if (this.company && this.company.renters) {
       this.collabList = this.company.renters.filter(item => item['@id'] !== this.userInfos['@id']);
    }
  },
  methods: {
    goToForm() {
      this.$router.push({name:'adminCollaboratorsForm'});
    },
    handleDelete(item) {
      this.toBeDeletedItem = item;
      this.dialog = true;
    },
    handleConfirm(){
      let newList = [];
      for (let i = 0; i < this.collabList.length; i++) {
        const collab = this.collabList[i];
        if (collab['@id'] !== this.toBeDeletedItem['@id']) {
          newList.push(collab['@id']);
        }
      }
      newList.push(this.userInfos['@id']);
      let newCompany = {
        ...this.company
      }
      newCompany.renters = newList;
      this.updateCompany(newCompany);
      this.dialog = false;

    },
    ...mapActions('admin', ['getCompanyInfosByOwner', 'createCompany', 'updateCompany']),
    ...mapActions('user', [ 'uploadProfilePicture'])
  },
  watch: {
    company(newCompany){
      if (newCompany && newCompany.renters) {
        // if (this.userInfos['@id'] === ) {
          this.collabList = newCompany.renters.filter(item => item['@id'] !== this.userInfos['@id']);
        // }
      }
    },
  }
};
</script>
